#[doc = "Register `D00` reader"]
pub struct R(crate::R<D00_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<D00_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<D00_SPEC>> for R {
    fn from(reader: crate::R<D00_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `D00` writer"]
pub struct W(crate::W<D00_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<D00_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<D00_SPEC>> for W {
    fn from(writer: crate::W<D00_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `D0_0` reader - Data 0 for UDB\\[n\\]"]
pub struct D0_0_R(crate::FieldReader<u8, u8>);
impl D0_0_R {
    pub(crate) fn new(bits: u8) -> Self {
        D0_0_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D0_0_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D0_0` writer - Data 0 for UDB\\[n\\]"]
pub struct D0_0_W<'a> {
    w: &'a mut W,
}
impl<'a> D0_0_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u32 & 0xff);
        self.w
    }
}
#[doc = "Field `D0_1` reader - Data 0 for UDB\\[n+1\\]"]
pub struct D0_1_R(crate::FieldReader<u8, u8>);
impl D0_1_R {
    pub(crate) fn new(bits: u8) -> Self {
        D0_1_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D0_1_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D0_1` writer - Data 0 for UDB\\[n+1\\]"]
pub struct D0_1_W<'a> {
    w: &'a mut W,
}
impl<'a> D0_1_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 8)) | ((value as u32 & 0xff) << 8);
        self.w
    }
}
#[doc = "Field `D0_2` reader - Data 0 for UDB\\[n+2\\]"]
pub struct D0_2_R(crate::FieldReader<u8, u8>);
impl D0_2_R {
    pub(crate) fn new(bits: u8) -> Self {
        D0_2_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D0_2_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D0_2` writer - Data 0 for UDB\\[n+2\\]"]
pub struct D0_2_W<'a> {
    w: &'a mut W,
}
impl<'a> D0_2_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 16)) | ((value as u32 & 0xff) << 16);
        self.w
    }
}
#[doc = "Field `D0_3` reader - Data 0 for UDB\\[n+3\\]"]
pub struct D0_3_R(crate::FieldReader<u8, u8>);
impl D0_3_R {
    pub(crate) fn new(bits: u8) -> Self {
        D0_3_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for D0_3_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `D0_3` writer - Data 0 for UDB\\[n+3\\]"]
pub struct D0_3_W<'a> {
    w: &'a mut W,
}
impl<'a> D0_3_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0xff << 24)) | ((value as u32 & 0xff) << 24);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Data 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn d0_0(&self) -> D0_0_R {
        D0_0_R::new((self.bits & 0xff) as u8)
    }
    #[doc = "Bits 8:15 - Data 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn d0_1(&self) -> D0_1_R {
        D0_1_R::new(((self.bits >> 8) & 0xff) as u8)
    }
    #[doc = "Bits 16:23 - Data 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn d0_2(&self) -> D0_2_R {
        D0_2_R::new(((self.bits >> 16) & 0xff) as u8)
    }
    #[doc = "Bits 24:31 - Data 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn d0_3(&self) -> D0_3_R {
        D0_3_R::new(((self.bits >> 24) & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Data 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn d0_0(&mut self) -> D0_0_W {
        D0_0_W { w: self }
    }
    #[doc = "Bits 8:15 - Data 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn d0_1(&mut self) -> D0_1_W {
        D0_1_W { w: self }
    }
    #[doc = "Bits 16:23 - Data 0 for UDB\\[n+2\\]"]
    #[inline(always)]
    pub fn d0_2(&mut self) -> D0_2_W {
        D0_2_W { w: self }
    }
    #[doc = "Bits 24:31 - Data 0 for UDB\\[n+3\\]"]
    #[inline(always)]
    pub fn d0_3(&mut self) -> D0_3_W {
        D0_3_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Data 0\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [d00](index.html) module"]
pub struct D00_SPEC;
impl crate::RegisterSpec for D00_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [d00::R](R) reader structure"]
impl crate::Readable for D00_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [d00::W](W) writer structure"]
impl crate::Writable for D00_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets D00 to value 0"]
impl crate::Resettable for D00_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
